var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) if (e.indexOf(p[i]) < 0)
            t[p[i]] = s[p[i]];
    return t;
};
import { createVNode } from 'inferno';
import { combineFrom, isBrowser, warning } from 'inferno-shared';
function renderLink(classNm, children, otherProps) {
    return createVNode(2 /* HtmlElement */, 'a', classNm, children, otherProps);
}
export default function Link(props, { router }) {
    const { activeClassName, activeStyle, className, onClick, children, to } = props, otherProps = __rest(props, ["activeClassName", "activeStyle", "className", "onClick", "children", "to"]);
    let classNm;
    if (className) {
        classNm = className;
    }
    if (!router) {
        if (process.env.NODE_ENV !== 'production') {
            warning('<Link/> component used outside of <Router/>. Fallback to <a> tag.');
        }
        otherProps.href = to;
        otherProps.onClick = onClick;
        return renderLink(classNm, children, otherProps);
    }
    otherProps.href = isBrowser ? router.createHref({ pathname: to }) : router.location.baseUrl ? router.location.baseUrl + to : to;
    if (router.location.pathname === to) {
        if (activeClassName) {
            classNm = (className ? className + ' ' : '') + activeClassName;
        }
        if (activeStyle) {
            otherProps.style = combineFrom(props.style, activeStyle);
        }
    }
    otherProps.onclick = function navigate(e) {
        if (e.button !== 0 || e.ctrlKey || e.altKey || e.metaKey || e.shiftKey) {
            return;
        }
        e.preventDefault();
        if (typeof onClick === 'function') {
            onClick(e);
        }
        router.push(to, e.target.textContent);
    };
    return renderLink(classNm, children, otherProps);
}
