import Component from 'inferno-component';
export default class RouterContext extends Component {
    constructor(props, context) {
        super(props, context);
        if (process.env.NODE_ENV !== 'production') {
            if (!props.location || !props.matched) {
                throw new TypeError('"inferno-router" requires a "location" and "matched" props passed');
            }
        }
    }
    getChildContext() {
        return {
            router: this.props.router || {
                location: {
                    baseUrl: this.props.baseUrl,
                    pathname: this.props.location
                }
            }
        };
    }
    render(props) {
        return props.matched;
    }
}
