"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var match_1 = require("./match");
/**
 * Returns a Promise containing only the matched components
 * @param routes
 * @param currentURL
 * @returns {*}
 */
function matchAsync(routes, currentURL) {
    return new Promise(function (resolve) {
        var renderProps = match_1.default(routes, currentURL);
        var node = renderProps.matched.props.children.props;
        if (node.getComponent) {
            node.getComponent({}, function (error, component) {
                node.component = component;
                resolve(renderProps);
            });
        }
        else {
            resolve(renderProps);
        }
    });
}
exports.default = matchAsync;
