import match from './match'

/**
 * Returns a Promise containing only the matched components
 * @param routes
 * @param currentURL
 * @returns {*}
 */
export default function matchAsync(routes, currentURL: any) {
	return new Promise(resolve => {
		const renderProps = match(routes, currentURL);
		const node = renderProps.matched.props.children.props
		if (node.getComponent) {
			node.getComponent({}, (error, component) => {
				node.component = component
				resolve(renderProps)
			})
		} else {
			resolve(renderProps)
		}
	})
}
